module(..., package.seeall)

-- Load libraries
require("controllerfunctions")

default_action = "status"

function status(self)
	return self.model.getstatus()
end

function startstop(self)
	return controllerfunctions.handle_startstop(self, self.model.startstop_service, self.clientdata)
end

function listfiles(self)
        return self.model.listconfigfiles()
end

function expert(self)
	return controllerfunctions.handle_form(self, function() return self.model.getconfigfile(self.clientdata.filename) end, self.model.setconfigfile, self.clientdata, "Save", "Edit Samba File", "File Saved")
end

function join(self)
	return controllerfunctions.handle_form(self, self.model.get_join, self.model.set_join, self.clientdata, "Join", "Join Domain")
end

function listshares(self)
	return self.model.list_shares()
end

function editshare(self)
	return controllerfunctions.handle_form(self, function() return self.model.read_share(self.clientdata.name) end, self.model.update_share, self.clientdata, "Save", "Edit Share", "Share Saved")
end

function deleteshare(self)
	return self:redirect_to_referrer(self.model.delete_share(self.clientdata.name))
end

function createshare(self)
	return controllerfunctions.handle_form(self, self.model.read_share, self.model.create_share, self.clientdata, "Create", "Create Share", "Share Created")
end
